open Softcore

(* Strategies : see developper doc *)

type t = ModelFound of Constraint.t | NoModelFound
(*
 *let (&) s1 s2 =
 *  match s1 with
 *  |ModelFound _ -> ModelFound
 *  |NoModelFound -> s2
 *)

let satisfiable = function
  |ModelFound _ -> true
  |NoModelFound -> false

let unsatisfiable = not <|| satisfiable

let model_hint = function
  |ModelFound c when Constraint.is_trivial c -> None
  |ModelFound c                              -> Some c
  |NoModelFound                              -> None
